// FunctionatorDoc.cpp : Implementierung der Klasse CFunctionatorDoc
//

#include "stdafx.h"
#include "Functionator.h"
#include "FunctionatorDoc.h"
#include "FunctionatorView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorDoc

IMPLEMENT_DYNCREATE(CFunctionatorDoc, CDocument)

BEGIN_MESSAGE_MAP(CFunctionatorDoc, CDocument)
	//{{AFX_MSG_MAP(CFunctionatorDoc)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_EN_CHANGE(IDC_FORMULA, OnChangeFormula)
	ON_BN_CLICKED(IDC_INSERT_SQRT, OnInsertSqrt)
	ON_BN_CLICKED(IDC_INSERT_COS, OnInsertCos)
	ON_BN_CLICKED(IDC_INSERT_SIN, OnInsertSin)
	ON_BN_CLICKED(IDC_INSERT_TAN, OnInsertTan)
	ON_COMMAND(ID_ANTIALIASING, OnAntialiasing)
	ON_UPDATE_COMMAND_UI(ID_ANTIALIASING, OnUpdateAntialiasing)
	ON_COMMAND(ID_GRADUATION, OnGraduation)
	ON_UPDATE_COMMAND_UI(ID_GRADUATION, OnUpdateGraduation)
	ON_COMMAND(ID_GRID, OnGrid)
	ON_UPDATE_COMMAND_UI(ID_GRID, OnUpdateGrid)
	ON_EN_CHANGE(IDC_RANGE_0, OnChangeRange0)
	ON_EN_CHANGE(IDC_RANGE_1, OnChangeRange1)
	ON_EN_CHANGE(IDC_STEP, OnChangeStep)
	ON_EN_CHANGE(IDC_SCALE_X, OnChangeScaleX)
	ON_EN_CHANGE(IDC_SCALE_Y, OnChangeScaleY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorDoc Konstruktion/Destruktion

CFunctionatorDoc::CFunctionatorDoc()
{

}

CFunctionatorDoc::~CFunctionatorDoc()
{
}

BOOL CFunctionatorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	//Standard initalisation
	// ( is used instead of constructor )

	scala[0] = 10.0f;
	scala[1] = 10.0f;
	rotation[0] = 0.0f;
	rotation[1] = 0.0f;
	rotation[2] = 0.0f;
	range[0] = -10.0f;
	range[1] = 10.0f;
	step = 0.1f;
	zoom = 1.0f;
	antialiasing = false;
	grid = true;
	graduation = true;

	((CMainFrame*)AfxGetMainWnd())->SetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CFunctionatorDoc Serialisierung

void CFunctionatorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		//CString string = function.getCharString();
		
		//MessageBox(NULL,string,"",MB_OK);

		

		//string += "\r\n\0";TRACE0(string);

		ar << antialiasing << graduation << grid
		   << range[0] << range[1] << rotation[0] << rotation[1]
		   << rotation[2] << scala[0] << scala[1] << step << zoom
		   << function;
	}
	else
	{
		//CString string;

		ar >> antialiasing >> graduation >> grid >> 
		 range[0] >> range[1] >> rotation[0] >> rotation[1]
		>> rotation[2] >> scala[0] >> scala[1] >> step >> zoom 
		>> function;

		//string += "\0";

		//TRACE0(string);

		//update function control and refresh window
		((CMainFrame*)AfxGetMainWnd())->SetFunctionValue(function);
		OnRefresh();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorDoc Diagnose

#ifdef _DEBUG
void CFunctionatorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFunctionatorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorDoc Befehle

void CFunctionatorDoc::OnRefresh() 
{
	CMainFrame* mainFrame = (CMainFrame*)AfxGetMainWnd();
	CFunctionatorView* view = (CFunctionatorView*)mainFrame->GetActiveView();
	
	function = mainFrame->GetFunctionValue().GetBuffer(0);

	//***** HOURGLASS + MESSAGE IN STATUSBAR

	CWaitCursor cursor;
	mainFrame->SetStatusBarText("Calculating curve...");
	
	//-----
	view->CalculateCurve();

	UpdateAllViews(NULL);
	//-----

	//***** OK, DONE *** 
	cursor.Restore();
	mainFrame->SetStatusBarText("Ready");
}

float* CFunctionatorDoc::GetRotation()
{
	return rotation;
}

float* CFunctionatorDoc::GetScala()
{
	return scala;
}

SString CFunctionatorDoc::GetFunction()
{
	return function.GetBuffer(0);
}

float* CFunctionatorDoc::GetRange()
{
	return range;
}

float* CFunctionatorDoc::GetStep()
{
	return &step;
}

void CFunctionatorDoc::OnChangeFormula() 
{
	SetModifiedFlag();	
}

void CFunctionatorDoc::OnInsertSqrt() 
{
	((CMainFrame*)AfxGetMainWnd())->AddToFunctionValue("sqrt( )");		
}	

void CFunctionatorDoc::OnInsertCos() 
{
	((CMainFrame*)AfxGetMainWnd())->AddToFunctionValue("cos( )");	
}

void CFunctionatorDoc::OnInsertSin() 
{
	((CMainFrame*)AfxGetMainWnd())->AddToFunctionValue("sin( )");	
}

void CFunctionatorDoc::OnInsertTan() 
{
	((CMainFrame*)AfxGetMainWnd())->AddToFunctionValue("tan( )");		
}

float* CFunctionatorDoc::GetZoom()
{
	return &zoom;
}

bool* CFunctionatorDoc::GetAntiA()
{
	return &antialiasing;
}

bool* CFunctionatorDoc::GetGraduation()
{
	return &graduation;
}

bool* CFunctionatorDoc::GetGrid()
{
	return &grid;
}

void CFunctionatorDoc::OnAntialiasing() 
{
	antialiasing = !antialiasing;
	UpdateAllViews(NULL);
	SetModifiedFlag();
}

void CFunctionatorDoc::OnUpdateAntialiasing(CCmdUI* pCmdUI) 
{
	
	pCmdUI->SetCheck(antialiasing);
}

void CFunctionatorDoc::OnGraduation() 
{
	graduation = !graduation;
	UpdateAllViews(NULL);
	SetModifiedFlag();
}

void CFunctionatorDoc::OnUpdateGraduation(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(graduation);
}

void CFunctionatorDoc::OnGrid() 
{
	grid = !grid;
	UpdateAllViews(NULL);
	SetModifiedFlag();
}

void CFunctionatorDoc::OnUpdateGrid(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(grid);
}

void CFunctionatorDoc::OnChangeRange0() 
{
	((CMainFrame*)AfxGetMainWnd())->GetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);
}

void CFunctionatorDoc::OnChangeRange1() 
{
	((CMainFrame*)AfxGetMainWnd())->GetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);
}

void CFunctionatorDoc::OnChangeStep() 
{
	((CMainFrame*)AfxGetMainWnd())->GetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);
}

void CFunctionatorDoc::OnChangeScaleX() 
{
	((CMainFrame*)AfxGetMainWnd())->GetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);
}

void CFunctionatorDoc::OnChangeScaleY() 
{
	((CMainFrame*)AfxGetMainWnd())->GetSceneValues(range[0],range[1],step,
		scala[0],scala[1]);	
}
