// FunctionatorView.cpp : Implementierung der Klasse CFunctionatorView
//

#include "stdafx.h"
#include "Functionator.h"

#include "FunctionatorDoc.h"
#include "FunctionatorView.h"
#include "MainFrm.h"

#include "Image.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




void swapRGB2BGR(unsigned char* array, int size)
{
	for (int i = 0; i < size; i += 3)
	{
		unsigned char temp = array[i];
		array[i] = array[i+2];
		array[i+2] = temp;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorView

IMPLEMENT_DYNCREATE(CFunctionatorView, CView)

BEGIN_MESSAGE_MAP(CFunctionatorView, CView)
	//{{AFX_MSG_MAP(CFunctionatorView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_COMMAND(ID_ROTATE_Z_RIGHT, OnRotateZRight)
	ON_COMMAND(ID_ROTATE_Z_LEFT, OnRotateZLeft)
	ON_COMMAND(ID_CAPTURE, OnCapture)
	ON_COMMAND(ID_RECENTER, Recenter)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorView Konstruktion/Destruktion

CFunctionatorView::CFunctionatorView()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,
	mouseDown = false;
}

CFunctionatorView::~CFunctionatorView()
{
	coords.RemoveAll();
}



/////////////////////////////////////////////////////////////////////////////
// CFunctionatorView Zeichnen

void CFunctionatorView::OnDraw(CDC* pDC)
{
	CFunctionatorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// ZU ERLEDIGEN: Hier Code zum Zeichnen der ursprnglichen Daten hinzufgen

	//***************** OPENGL ****************

	DrawGL();

	SwapBuffers(pDC->GetSafeHdc());
}

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorView Diagnose

#ifdef _DEBUG
void CFunctionatorView::AssertValid() const
{
	CView::AssertValid();
}

void CFunctionatorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFunctionatorDoc* CFunctionatorView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFunctionatorDoc)));
	return (CFunctionatorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFunctionatorView Nachrichten-Handler

int CFunctionatorView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	openGLDevice.create(GetDC()->m_hDC);
	InitGL();

	//get pointers from doc where all relevant
	//vars are saved (cause of serialization)
	rotation = GetDocument()->GetRotation();
	scala = GetDocument()->GetScala();
	range = GetDocument()->GetRange();
	step = GetDocument()->GetStep();
	zoom = GetDocument()->GetZoom();
	antialising = GetDocument()->GetAntiA();
	grid = GetDocument()->GetGrid();
	graduation = GetDocument()->GetGraduation();
		
	
	return 0;
}

void CFunctionatorView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);

	glViewport(0, 0, cx, cy);	

	glMatrixMode(GL_PROJECTION);						
	glLoadIdentity();						

	glOrtho(-scala[0]-1,scala[0]+1,-scala[1]-1,scala[1]+1,-100.0,100.0f);

	glMatrixMode(GL_MODELVIEW);						
	glLoadIdentity();

	//status bar info
	CMainFrame* mainFrame = (CMainFrame*)AfxGetMainWnd();
	if (mainFrame)
		mainFrame->SetSizeBarInfo(cx,cy);
}

void CFunctionatorView::InitGL()
{
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glLineWidth(0.75);
}

void CFunctionatorView::DrawGL()
{
	glClear(GL_COLOR_BUFFER_BIT);

	glLoadIdentity();

	glScalef(*zoom,*zoom,1.0f);

	glRotatef(rotation[0],1.0f,0.0f,0.0f);
	glRotatef(rotation[1],0.0,1.0f,0.0f);
	glRotatef(rotation[2],0.0f,0.0f,1.0f);

	//antialising ?

	if (*antialising)
		glEnable(GL_LINE_SMOOTH);
	else
		glDisable(GL_LINE_SMOOTH);

	//main funcs
	if (*grid)
		DrawGrid();
	DrawFunction();
}

void CFunctionatorView::DrawGrid()
{
	glColor3f(0.0f,0.6f,0.0f);

	//Lines

	glBegin(GL_LINES);
		glVertex2f(0.0f,scala[1]);
		glVertex2f(0.0f,-scala[1]);
		glVertex2f(-scala[0],0.0f);
		glVertex2f(scala[0],0.0f);

		//*****************
		// Graduation
		//*****************
		
		if (*graduation)
		{
					//on x
			for (float x = -scala[0]+1.0f; x <= scala[0]-1.0f; x += 1.0f)
			{
				//TRACE2("%d , %f\n",x,0.0f);
				glVertex2f(x,0.15f);
				glVertex2f(x,-0.15f);
			}

			//on y
			for (float y = -scala[1]+1.0f; y <= scala[1]-1.0f; y += 1.0f)
			{
				//TRACE2("%d , %f\n",x,0.0f);
				glVertex2f(0.15f,y);
				glVertex2f(-0.15f,y);
			}
		}
	glEnd();

	
	//Triangles 

	glBegin(GL_TRIANGLES);
		glVertex2f(0.0f,scala[1]+0.1f);
		glVertex2f(-0.2f,scala[1]-0.3f);
		glVertex2f(0.2f,scala[1]-0.3f);

		glVertex2f(scala[0]+0.1f,0.0f);
		glVertex2f(scala[0]-0.3f,-0.2f);
		glVertex2f(scala[0]-0.3f,0.2f);
	glEnd();

}

void CFunctionatorView::Recenter()
{
	rotation[0] = 0.0f;
	rotation[1] = 0.0f;
	rotation[2] = 0.0f;
	*zoom = 1.0f;

	//redraw to see changes
	InvalidateRect(NULL);
}

void CFunctionatorView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	Recenter();

	CView::OnLButtonDblClk(nFlags, point);
}

void CFunctionatorView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetCapture();
	lastPoint = point;
	mouseDown = true;
	
	CView::OnLButtonDown(nFlags, point);
}

void CFunctionatorView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();
	mouseDown = false;
	
	CView::OnLButtonUp(nFlags, point);
}

void CFunctionatorView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (mouseDown)
	{
		//MessageBox("MOVING");
		rotation[0] += float(point.y-lastPoint.y);
		rotation[1] -= float(point.x-lastPoint.x);

		lastPoint = point;

		//redraw to see changes
		InvalidateRect(NULL);
		
		//changed document -> is modified
		GetDocument()->SetModifiedFlag();
	}

	

	CView::OnMouseMove(nFlags, point);
}

BOOL CFunctionatorView::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CFunctionatorView::DrawFunction()
{
	glBegin(GL_LINE_STRIP);
	
	glColor3f(0.0f,0.6f,0.0f);
	
	for (int i=0;i < coords.GetSize();i+=2)
	{
		glVertex2f(coords[i],coords[i+1]);
	}

	glEnd();
}

void CFunctionatorView::CalculateCurve()
{
	//emtpy
	coords.RemoveAll();

	SString function = GetDocument()->GetFunction();
	SString calc;
	float y;

	for (float x = range[0];x <= range[1]; x += *step )
	{
		calc = function;
		calc.replace("x",x);
		
		y = calculator.parse(calc);
		
		coords.Add(x);
		coords.Add(y);
	}

	//resize view as the scale might have been changed
	// -> viewport resized
	CRect rect;
	GetClientRect(rect);
		
	OnSize(0,rect.Width(),rect.Height());
}

void CFunctionatorView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu* menu = AfxGetMainWnd()->GetMenu();

	CMenu* popup = menu->GetSubMenu(3);

	popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
			point.x,point.y,this);
}

void CFunctionatorView::OnZoomIn() 
{
	(*zoom) += 0.05f;

	//update view
	InvalidateRect(NULL);
	GetDocument()->SetModifiedFlag();
}

void CFunctionatorView::OnZoomOut() 
{
	(*zoom) -= 0.05f;
	
	//update view
	InvalidateRect(NULL);
	GetDocument()->SetModifiedFlag();
}

void CFunctionatorView::OnRotateZRight() 
{
	rotation[2] -= 1.0f;

	//update view
	InvalidateRect(NULL);
	GetDocument()->SetModifiedFlag();
}

void CFunctionatorView::OnRotateZLeft() 
{
	rotation[2] += 1.0f;

	//update view
	InvalidateRect(NULL);
	GetDocument()->SetModifiedFlag();
}

void CFunctionatorView::OnCapture() 
{
	CFileDialog fileDialog(
	false,
	"",
	NULL,
	OFN_OVERWRITEPROMPT,
	"Windows Bitmap (*.bmp)|*.bmp|Truevision Targa (*.tga)|*.tga||");
	
	if (fileDialog.DoModal() == IDOK)
	{
		CRect rect;
		GetClientRect(rect);

		//buffer & read pixels from screen
		char* buffer = new char[rect.Width()*rect.Height()*3];

		glReadPixels(0,0,rect.Width(),rect.Height(),GL_RGB,
			GL_UNSIGNED_BYTE,buffer);

		//Write BMP or TGA

		CString string = fileDialog.GetFileExt();
		string.MakeUpper();
		
		if (string == "BMP")
		{
			WriteBitmapFile(fileDialog.GetPathName().GetBuffer(0),rect.Width(),
				rect.Height(),(unsigned char*)buffer);
		}
		else if (string == "TGA")
		{
			WriteTGAFile(fileDialog.GetPathName().GetBuffer(0),rect.Width(),
				rect.Height(),(unsigned char*)buffer);
		}

		//delete buffer

		delete[] buffer;

	}
}

void CFunctionatorView::OnEditCopy() 
{
/*	if (!OpenClipboard())
	{
		return;
	}

	if (!EmptyClipboard())
	{
		return;
	}

	clipboard.DeleteObject();

	//create bitmap first with data from OpenGL
	//device and size 

	CRect rect;
	GetClientRect(rect);

	int size = rect.Width()*rect.Height()*3;

	unsigned char* buffer  = new unsigned char[size];

//	glPixelStorei(GL_PACK_ALIGNMENT,4);

	glReadPixels(0,0,rect.Width(),rect.Height(),GL_RGB,
		GL_UNSIGNED_BYTE,buffer);

	swapRGB2BGR(buffer,size);

	clipboard.CreateBitmap(rect.Width(),rect.Height(),1,24,
			buffer);

	
	
	::SetClipboardData(CF_BITMAP,clipboard);

	CloseClipboard();
	
	delete[] buffer;*/
}
