// FunctionatorView.h : Schnittstelle der Klasse CFunctionatorView
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FUNCTIONATORVIEW_H__5B6C89F2_CE42_4885_90DA_2E2A6860F7AC__INCLUDED_)
#define AFX_FUNCTIONATORVIEW_H__5B6C89F2_CE42_4885_90DA_2E2A6860F7AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>
#include <GL\gl.h>
#include "OpenGLDevice.h"
#include "SCalculator.h"

class CFunctionatorView : public CView
{
protected: // Nur aus Serialisierung erzeugen
	CFunctionatorView();
	DECLARE_DYNCREATE(CFunctionatorView)

// Attribute
public:
	CFunctionatorDoc* GetDocument();

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CFunctionatorView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	protected:
	//}}AFX_VIRTUAL

// Implementierung
public:
	void CalculateCurve();
	virtual ~CFunctionatorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CBitmap clipboard;
	OpenGLDevice openGLDevice;
	SCalculator calculator;
	CArray<float,float&> coords;
	float* scala;
	float* rotation;
	float* range;
	float* step;
	float* zoom;
	
	bool* antialising;
	bool* grid;
	bool* graduation;

	bool mouseDown;
	CPoint lastPoint;
// Generierte Message-Map-Funktionen
protected:
	void DrawFunction();
	void Recenter();
	void DrawGrid();
	void DrawGL();
	void InitGL();
	//{{AFX_MSG(CFunctionatorView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnRotateZRight();
	afx_msg void OnRotateZLeft();
	afx_msg void OnCapture();
	afx_msg void OnEditCopy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in FunctionatorView.cpp
inline CFunctionatorDoc* CFunctionatorView::GetDocument()
   { return (CFunctionatorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_FUNCTIONATORVIEW_H__5B6C89F2_CE42_4885_90DA_2E2A6860F7AC__INCLUDED_)
