// MainFrm.cpp : Implementierung der Klasse CMainFrame
//

#include "stdafx.h"
#include "Functionator.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_SCENEBAR, OnViewScenebar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SCENEBAR, OnUpdateViewScenebar)
	ON_COMMAND(ID_VIEW_ADVANCEDSCENEBAR, OnViewAdvancedscenebar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ADVANCEDSCENEBAR, OnUpdateViewAdvancedscenebar)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Statusleistenanzeige
	ID_SCENE_SIZE
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Konstruktion/Zerstrung

CMainFrame::CMainFrame()
{
	// ZU ERLEDIGEN: Hier Code zur Member-Initialisierung einfgen
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	EnableDocking(CBRS_ALIGN_ANY);
	
	//*********************
	//TOOLBARS
	//*********************

	//standard (file)

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	m_wndToolBar.SetWindowText("File");

	//scene

	if (!sceneToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!sceneToolBar.LoadToolBar(IDR_SCENE))
	{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	sceneToolBar.SetWindowText("Scene");


	//*****************
	//STATUSBAR
	//*****************

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;      // Fehler bei Erstellung
	}

	//*************
	// Dialogbar I
	//*************

	dialogBar.Create(this,IDD_FORMULABAR,CBRS_BOTTOM,IDD_FORMULABAR);
		
	dialogBar.EnableDocking(CBRS_ALIGN_ANY);
	dialogBar.SetWindowText("Function");

	//*************
	// Dialogbar II
	//*************

	sceneDlgBar.Create(this,IDD_SCENE_BAR,CBRS_TOP | CBRS_GRIPPER | 
		CBRS_FLYBY ,IDD_SCENE_BAR);

	sceneDlgBar.EnableDocking(CBRS_ALIGN_TOP | CBRS_ALIGN_BOTTOM);
	sceneDlgBar.SetWindowText("Scene Properties");
	

	// ZU ERLEDIGEN: Lschen Sie diese drei Zeilen, wenn Sie nicht wollen, dass die Symbolleiste
	//  andockbar ist.
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	
	sceneToolBar.EnableDocking(CBRS_ALIGN_ANY);
	
	
	DockControlBar(&m_wndToolBar);
	DockControlBar(&sceneToolBar);
	DockControlBar(&sceneDlgBar);
	//DockControlBar(&dialogBar,CBRS_BOTTOM);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	cs.cx = 595;
	cs.cy = 665;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Diagnose

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Nachrichten-Handler


CString CMainFrame::GetFunctionValue()
{
	CString string;
	CWnd* window = dialogBar.GetDlgItem(IDC_FORMULA);
	window->GetWindowText(string);

	return string;
}

void CMainFrame::SetStatusBarText(CString string)
{
	m_wndStatusBar.SetWindowText(string);
}

void CMainFrame::SetSizeBarInfo(int cx, int cy)
{
	if (!m_wndStatusBar.m_hWnd)
		return;

	//update status bar text

	//space
	bool space = true;
	if (cx >=  1000 || cy >= 1000)
		space = false;


	CString string;
	string.Format("%s%dx%d",(space?" ":""),cx,cy);

	m_wndStatusBar.SetPaneText(1,string);
}

void CMainFrame::AddToFunctionValue(CString string)
{
	CString text;
	CWnd* window = dialogBar.GetDlgItem(IDC_FORMULA);
	
	window->GetWindowText(text);
	window->SetWindowText(text+string);
	window->SetFocus();
	
}

void CMainFrame::SetFunctionValue(CString string)
{
	CString text;
	CWnd* window = dialogBar.GetDlgItem(IDC_FORMULA);
	
	window->SetWindowText(string);
	window->SetFocus();
}

void CMainFrame::OnViewScenebar() 
{
	bool visible = ((sceneToolBar.GetStyle() & WS_VISIBLE) != 0);
	
	ShowControlBar(&sceneToolBar,!visible,FALSE);

	RecalcLayout();
}

void CMainFrame::OnUpdateViewScenebar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sceneToolBar.GetStyle() & WS_VISIBLE) != 0);
}

void CMainFrame::OnViewAdvancedscenebar() 
{
	bool visible = ((sceneDlgBar.GetStyle() & WS_VISIBLE) != 0);
	
	ShowControlBar(&sceneDlgBar,!visible,FALSE);

	RecalcLayout();	
}

void CMainFrame::OnUpdateViewAdvancedscenebar(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sceneDlgBar.GetStyle() & WS_VISIBLE) != 0);	
}

void CMainFrame::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu* menu = GetMenu()->GetSubMenu(2);

	menu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
			point.x,point.y,this);
}

void CMainFrame::GetSceneValues(float &range0, float &range1, float &step,
				float &scaleX, float &scaleY)
{
	CString string;

	sceneDlgBar.GetDlgItem(IDC_RANGE_0)->GetWindowText(string);
	range0 = atof(string);

	sceneDlgBar.GetDlgItem(IDC_RANGE_1)->GetWindowText(string);
	range1 = atof(string);

	sceneDlgBar.GetDlgItem(IDC_STEP)->GetWindowText(string);
	step = atof(string);

	sceneDlgBar.GetDlgItem(IDC_SCALE_X)->GetWindowText(string);
	scaleX = atof(string);

	sceneDlgBar.GetDlgItem(IDC_SCALE_Y)->GetWindowText(string);
	scaleY = atof(string);
}

void CMainFrame::SetSceneValues(float &range0, float &range1, float &step,
				float &scaleX, float &scaleY)
{
	CString string;
	string.Format("%.3f",range0);
	sceneDlgBar.GetDlgItem(IDC_RANGE_0)->SetWindowText(string);

	string.Format("%.3f",range1);
	sceneDlgBar.GetDlgItem(IDC_RANGE_1)->SetWindowText(string);

	string.Format("%.3f",step);
	sceneDlgBar.GetDlgItem(IDC_STEP)->SetWindowText(string);

	string.Format("%.1f",scaleX);
	sceneDlgBar.GetDlgItem(IDC_SCALE_X)->SetWindowText(string);

	string.Format("%.1f",scaleY);
	sceneDlgBar.GetDlgItem(IDC_SCALE_Y)->SetWindowText(string);
}
