// SCalculator.h: Schnittstelle fr die Klasse SCalculator.
//
//////////////////////////////////////////////////////////////////////

#ifndef S_CALCULATOR_H
#define S_CALCULATOR_H

#include "SString.h"

#define MAX_TOKEN 128

//***
//Zustzliche Structs/Enums
//***

enum SType
{ IS='=', LP='(', RP=')', MINUS='-', PLUS='+',MUL='*',DIV='/',DIV2=':',NUMBER='o',
	NAME='n',NONE='\0',POW='^',ABS='|',FUNC='f'};


struct SToken
{
public:	
	SToken() 
	{
		type = NONE;
	}
	
	SString value;
	SType type;


	inline void operator =(SToken& rhs)
	{
		value = rhs.value;
		type = rhs.type;
	}
};

//Variables

struct SVariable
{
public:
	SVariable()
	{
		value = 0.0;
		next = NULL;
	}

	~SVariable()
	{
		//delete all children
		if (next != NULL)
		{
			delete next;
		}
	}

	SString name;
	double value;
	SVariable* next;
};



//***
//Main class
//***

class SCalculator  
{
public:
	void printVars();
	int getNextEndToken(SType token, int begin=-1, int end=-1);
	SCalculator();
	virtual ~SCalculator();
	

	double calculate(int begin=-1,int end=-1);
	double parse(SString& expression);
protected:
	SVariable* variableExists(SString& name);
	SString getNextName(int index);
	
	void addVariable(SString name, double value);
	void postParse();

	int getNextOper(SType oper, int begin=-1,int end=-1,bool reverse=false);
	
	double getVariable(SString name);
	double getNextNumber(int begin, bool reverse=false);
	double getResult(int index);
	double processFunction(SString& func,double parameter);

	SToken tokens[MAX_TOKEN];
	SVariable* varList;
	int size;
};

#endif 